<?php

/**
 * Matomo - free/libre analytics platform
 *
 * @link    https://matomo.org
 * @license https://www.gnu.org/licenses/gpl-3.0.html GPL v3 or later
 */

namespace Piwik\Plugins\Monolog\Handler;

use Monolog\Handler\AbstractHandler;
use Monolog\LogRecord;

class LogCaptureHandler extends AbstractHandler
{
    /**
     * @var LogRecord[]
     */
    private $allLogs;

    public function handle(LogRecord $record): bool
    {
        $this->allLogs[] = $record;

        return false;
    }

    /**
     * Returns all records. The records should be processed, so one could just use $record->message.
     *
     * @return LogRecord[]
     */
    public function getAllRecords()
    {
        return $this->allLogs;
    }
}
